import FormAddActionController from './form_add_action_controller';

export default class extends FormAddActionController {
  static targets = ['fileInput'];

  connect() {
    super.connect();
    this.fileInputTarget.addEventListener('change', () => this.updateSubmitVisibility());
  }

  disconnect() {
    super.disconnect();
    this.fileInputTarget.removeEventListener('change', () => this.updateSubmitVisibility());
  }

  updateSubmitVisibility() {
    let shouldShowSubmit = this.fileInputTarget.files.length > 0;

    if (shouldShowSubmit && this.hasAddActionTarget && this.addActionTarget.checked) {
      shouldShowSubmit = !!this.nextActionTarget.value;
    }

    this.submitButtonTarget.classList.toggle('hidden', !shouldShowSubmit);
    this.updateSubmitContent();
  }
}
