import { Controller } from '@hotwired/stimulus';

export default class extends Controller {
  static targets = ['submitButton', 'submitText', 'addAction', 'nextAction'];

  connect() {
    if (this.hasAddActionTarget && this.hasNextActionTarget) {
      this.addActionTarget.addEventListener('change', () => this.updateSubmitVisibility());
      this.nextActionTarget.addEventListener('change', () => this.updateSubmitVisibility());
    }
  }

  disconnect() {
    if (this.hasAddActionTarget && this.hasNextActionTarget) {
      this.addActionTarget.removeEventListener('change', () => this.updateSubmitVisibility());
      this.nextActionTarget.removeEventListener('change', () => this.updateSubmitVisibility());
    }
  }

  updateSubmitVisibility() {
    throw new Error('The method updateSubmitVisibility must be implemented.');
  }

  updateSubmitContent() {
    const text = this.hasAddActionTarget && this.addActionTarget.checked ? "Valider et passer à l'action suivante" : 'Valider';

    this.submitTextTarget.textContent = text;
  }
}
