# frozen_string_literal: true

module SpiritHub
  class TagsetsMailer < SpiritHub::ApplicationMailer
    # rubocop:disable Metrics/ParameterLists
    def share(upload:, subject:, message:, to:, cc: nil, bcc: nil)
      @user = upload.user
      @message = message
      # NOTE: Temporary, since we'll change this link soon.
      # For some reason routes from core are not visible here, so I'm constructing it manually.
      @share_link = "https://#{APP_CONFIG['app_host']}/upload/#{upload.id}"

      from = @user&.email_with_name.presence || APP_CONFIG['smtp_no_reply']

      mail(
        from:,
        return_path: from,
        to:,
        cc:,
        bcc:,
        subject:
      )
    end
    # rubocop:enable Metrics/ParameterLists
  end
end
